
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  clrPaleVioletRed
#property indicator_color2  clrPaleVioletRed
#property indicator_color3  clrDeepSkyBlue
#property indicator_color4  clrDeepSkyBlue
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2

//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame        = PERIOD_CURRENT;
extern bool            alertsOn         = true;
extern bool            alertsOnCurrent  = false;
extern bool            alertsMessage    = true;
extern bool            alertsSound      = true;
extern bool            alertsNotify     = true;
extern bool            alertsEmail      = false;
extern string          soundFile        = "alert2.wav";

extern bool            showInsideBar    = true;
extern bool            showOutsideBar   = false;
extern bool            SignalOnFirstBar = true;

//
//
//
//
//

double val1[];
double val2[];
double val3[];
double val4[];
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,val1); 
   SetIndexBuffer(1,val2); 
   SetIndexBuffer(2,val3); 
   SetIndexBuffer(3,val4); 
   if (showInsideBar)
   {
     SetIndexStyle(0,DRAW_HISTOGRAM); SetIndexLabel(0,"in hi");
     SetIndexStyle(1,DRAW_HISTOGRAM); SetIndexLabel(1,"in lo");
   }
   else
   {
     SetIndexStyle(0,DRAW_NONE);
     SetIndexStyle(1,DRAW_NONE); 
   }
   if (showOutsideBar)
   {
     SetIndexStyle(2,DRAW_HISTOGRAM); SetIndexLabel(2,"out hi");
     SetIndexStyle(3,DRAW_HISTOGRAM); SetIndexLabel(3,"out lo");
   }
   else
   {
     SetIndexStyle(2,DRAW_NONE);
     SetIndexStyle(3,DRAW_NONE); 
   }
   
   
       //
       //
       //
       //
       //
      
        indicatorFileName = WindowExpertName();
        returnBars        = TimeFrame==-99;
        TimeFrame         = MathMax(TimeFrame,_Period);
      
       //
       //
       //
       //
       //
       
   IndicatorShortName(timeFrameToString(TimeFrame)+" Inside Out Bar");
return(0);
}

//+------------------------------------------------------------------
//| 
//+------------------------------------------------------------------
//
//

int deinit(){ return(0);  }

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
            if (returnBars) { val1[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (TimeFrame==Period())
   {
     for(i=limit; i>=0; i--) 
     {
        double H1 = iHigh(NULL,0,i+1);
        double L1 =  iLow(NULL,0,i+1);
        double H  = iHigh(NULL,0,i);
        double L  =  iLow(NULL,0,i);
        
        val1[i] = EMPTY_VALUE;
        val2[i] = EMPTY_VALUE;
        val3[i] = EMPTY_VALUE;
        val4[i] = EMPTY_VALUE;
           if (H1>H&&L1<L) { val1[i] = High[i]; val2[i] = Low[i]; }
           if (H1<H&&L1>L) { val3[i] = High[i]; val4[i] = Low[i]; } 
    
      }
      
      //
      //
      //
      //
      //
      
      if (alertsOn)
      {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,TimeFrame,whichBar)); 
      
      //
      //
      //
      //
      //
      
      if (val1[whichBar+1] == EMPTY_VALUE && val1[whichBar] != EMPTY_VALUE && val2[whichBar+1] == EMPTY_VALUE && val2[whichBar] != EMPTY_VALUE) doAlert(whichBar,"inside bar");
      if (val3[whichBar+1] == EMPTY_VALUE && val3[whichBar] != EMPTY_VALUE && val4[whichBar+1] == EMPTY_VALUE && val4[whichBar] != EMPTY_VALUE) doAlert(whichBar,"outside bar");
    }         
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   int shift = -1; if (SignalOnFirstBar) shift=1;
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for (i=limit;i>=0; i--)
    {
       int y = iBarShift(NULL,TimeFrame,Time[i]);
       int x = iBarShift(NULL,TimeFrame,Time[i+shift]); 
       if (x!=y)
       {
          val1[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,0,y);
          val2[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,1,y);
          val3[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,2,y);
          val4[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,3,y); 
       } 
       else
       {
          val1[i]  = EMPTY_VALUE;
          val2[i]  = EMPTY_VALUE;
          val3[i]  = EMPTY_VALUE;
          val4[i]  = EMPTY_VALUE;
       }
    }
return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Inside Out Bar ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " Inside Out Bar "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}

